<?php session_start();
//WEB_NEWS Version 1.0 Copyright by Robert Augustin
//Diese Software ist Freeware. Keine Haftung. 

/* 1. Messung der Berechnungszeit der Seite Anfang  */
/* 2. Vorbereitungen */
/* 3. Datei und Modus bestimmen und prfen */
/* 4. Login-Informationen und Rechte*/
/* 5. Caching Leseprozess*/
/* 6. Archivieren */
/* 7. Kopfdaten und Artikeldaten einlesen */
/* 8. Links im Kopfbereich hinzufgen*/
/* 9. Modul zum Sortieren Anfang */
/* 10. Templates fr Textbausteine */
/* 11. Durchlauf der Datenbloecke */
/* 12. Messung der Berechnungszeit der Seite Ende (siehe 1.) */
/* 13. Montage und Ausgabe der Daten */
/* 14. Caching Schreibprozess*/


//echo '<pre>'; print_r($_REQUEST); echo '</pre>';// die;
//echo '<pre>'; print_r($_SESSION); echo '</pre>';// die;


/* 1. Messung der Berechnungszeit der Seite Anfang  */
function microtime_float()
{
    list($usec, $sec) = explode(" ", microtime());
    return (floatval($usec) + floatval($sec));
}

$Start_time = microtime_float();
for ($e=0;$e<1;$e++){$T_INHALTE='';$T_VERWEISE='';

/* 2. Vorbereitungen */
    /* 2.a) Include */
include_once ('Functionen_CMS.php');
$Daten_ary = array();

/* 3. Datei und Modus bestimmen und prfen */
    /* 3.a) Name fr Datenbank festlegen */
if ($_REQUEST['Datenbank']){
$Datenbank = $_REQUEST['Datenbank'];}
else {$Datenbank = 'CMS_Daten.dat';}
    /* 3.b) ? Datenbank lesen: Ja */
if ( is_readable ($Datenbank)){
$ganze_CMS = Artikel_lesen($Datenbank);
$T_CSS = $ganze_CMS[_Titel]['CSS_Sheet'];
if (! file_exists($T_CSS)){$T_CSS='CMS_2007.css';}
//print_r($ganze_CMS);die;
        /* 3.b)1. Keine Archivdatei */
if (substr($Datenbank,0,6) == 'Archiv'){
$Archivdatei = '';
$ArchivModus = 'Ja';}
        /* 3.b)2. Archivdatei ffnen */
else {
$Archivdatei = $ganze_CMS['_Titel']['Archiv'];
$ArchivModus = 'Nein';}
} 
    /* 3.c) ? Datenbank lesen: Nein */
else {Meldung('!File',$Datenbank);die;}

/* 4. Login-Informationen und Rechte*/
    /* 4.a Dateiinterne Ausnahmen einlesen*/
$tempUser = array(); $tempAdmin = array();$Rechte='Keine';$UserID='';
        /* User, die als Admin zugelassen sind*/
if ($ganze_CMS['_Titel']['Admin'] !=''){
$tempAdmin = explode('--y11--',$ganze_CMS['_Titel']['Admin']);}
        /* Auswahl bestimmter User*/
if ($ganze_CMS['_Titel']['User'] !=''){
$tempUser = explode('--y11--',$ganze_CMS['_Titel']['User']);}

        /* Jedes LOGIN unterbinden */
if (! in_array('Keine',$tempUser)){

    /* 4.b Wenn mglich: Externe Logindaten holen*/
if (file_exists('Func_Rechte_extern.php')){
include_once ('Func_Rechte_extern.php');
$temp = @ Rechte_ermitteln();
$Rechte = $temp['Rechte']; 
$UserID = $temp['Benutzername'];
}
    /* 4.c Sonst:*/
elseif ($_SESSION['PASSWORD'] AND $_SESSION['PASSWORD']['Benutzername']!=''){
$LogoutZeigen='Ja';
if ($_SESSION[PASSWORD][Datenbank]!=$Datenbank){
include_once ('Login/LOG_functionen.php');
$temppassw =login_pruefen($_SESSION['PASSWORD']['Benutzername'],'TestenYYYY5','Login/User.txt');
$_SESSION['PASSWORD']['Rechte']=$temppassw[ID][Rechte];
//echo $_SESSION['PASSWORD']['Rechte'];
$_SESSION[PASSWORD][Datenbank]=$Datenbank;}
$Rechte = $_SESSION['PASSWORD']['Rechte']; 
$UserID = $_SESSION['PASSWORD']['Benutzername'];
//echo $_SESSION['PASSWORD']['Rechte'];
//echo $Rechte;
//echo $UserID;
}
else {
$LoginZeigen='Ja';
$Rechte='Keine';
$UserID='xxyyxx1234zz';
}

    /* 4.d Dateibezogene Regeln anwenden:*/
if (in_array($UserID,$tempAdmin)) {$Rechte='Admin';}
if (($Rechte=='Admin' OR $Rechte=='User') AND count($tempUser)>0 AND ! in_array($UserID,$tempUser)) {
//unset ($_SESSION['PASSWORD']);
$Rechte='Keine';}
}

//echo '<br />' . $_SESSION['PASSWORD']['Rechte'];
//echo 'Rechte: ' . $Rechte;echo 'BN: ' . $UserID;

/* 5. Caching Leseprozess*/
    //Nicht eingeloggt?
if ($Rechte=='Keine' AND !$_SESSION['PASSWORD']){
$CacheDatei = substr($Datenbank,0,strlen($Datenbank)-4) . '_cache.html';
$aktCacheDateien = array ($T_CSS,$Datenbank);
$CacheOrder = Cache_lesen($CacheDatei,$aktCacheDateien); 
}

/* 6. Archivieren */
if ($_REQUEST['archivieren']){
    /* 6.a) Archivdatei beschreibbar? Ja */
if ( is_writeable ($ganze_CMS['_Titel']['Archiv'])){
$ganzes_Archiv = Artikel_lesen($Archivdatei);
        /* 6.a)1. Archiveintrag existiert schon: weiter! */
if (array_key_exists($_REQUEST['archivieren'],$ganzes_Archiv))
{Meldung('Archiveintrag_existiert',$_REQUEST['archivieren'],$Archivdatei);}
        /* 4.a)2. Archivierungsvorgang mit Meldungen */
else {
$ganzes_Archiv[$_REQUEST['archivieren']]=$ganze_CMS[$_REQUEST['archivieren']]; 
if(Artikeldatei_Schreiben($Archivdatei,$ganzes_Archiv)==TRUE){
unset ($ganze_CMS[$_REQUEST['archivieren']]);
if(Artikeldatei_Schreiben($Datenbank,$ganze_CMS)==TRUE)
{Meldung ('Datei_geschrieben',$Datenbank);} 
else {Meldung ('Datei_nicht_geschrieben',$Datenbank);} 

Meldung ('Datei_geschrieben',$Archivdatei);} 
else {Meldung ('Datei_nicht_geschrieben',$Archivdatei);} 
}
}
    /* 6.b) Archivdatei beschreibbar? Nein */
else {Meldung('nicht_archivierbar',$ganze_CMS['_Titel']['Archiv']);}
//die;
}

/* 7. Kopfdaten und Artikeldaten einlesen */
$T_GESAMTTITEL = $ganze_CMS[_Titel][0];

//Alternative 1 ist alt und langsamer:
//$Daten_ary = Artikel_lesen($Datenbank,'Artikel');
//Alternative 2:
foreach ($ganze_CMS as $ckey => $cvalue){
switch (substr($ckey,0,7)){
case 'Artikel': 
$Daten_ary[$ckey]=$cvalue;break;}
}

/* 8. Links im Kopfbereich hinzufgen*/
   /* 8.a. Link Artikel hinzufgen 
      (Wenn User berechtigt UND   nicht Archivmodus) */
if (($Rechte == 'User' OR $Rechte == 'Admin') AND $ArchivModus == 'Nein'){
$T_NEUER_ARTIKEL = '<div class="Link_bearbeiter_0marg"><a href="body_CMS_Formular.php?Datenbank='.$Datenbank.'" >Neuen Artikel hinzufgen</a>
<br /><a href="Erste_Schritte.pdf" >Hilfe</a></div>';}

   /* 8.b. Link Basisdaten 
      (Wenn Administator UND nicht Archivmodus) */
if ($Rechte == 'Admin' AND $ArchivModus == 'Nein'){
$T_NEUER_ARTIKEL .= '<div class="Link_bearbeiter_0marg"><a href="body_CMS_BasisdatenFormular.php?Datenbank='.$Datenbank.'" >Basisdaten &auml;ndern</a></div>';}

   /* 8.c. Link Login/Logout zeigen */
if ($LoginZeigen=='Ja' AND substr($Datenbank,0,6)!='Archiv'){
$T_NEUER_ARTIKEL .= '<div class="Link_bearbeiter_0marg"><a href="Login/Login.php?Datenbank='.$Datenbank.'" >Anmelden</a></div>';}

   /* 8.d. Link Login/Logout zeigen */
if ($LogoutZeigen=='Ja' AND substr($Datenbank,0,6)!='Archiv'){
$T_NEUER_ARTIKEL .= '<div class="Link_bearbeiter_0marg"><a href="Login/Logout.php?Datenbank='.$Datenbank.'" >Abmelden</a></div>';}


/* 9. Modul zum Sortieren Anfang */
foreach ($Daten_ary as $key => $row) {
    $Datum[$key]  = $row['2'];
    $Prioritaet[$key] = $row['5'];
}
if ($ArchivModus == 'Ja'){
@ array_multisort ($Datum, SORT_ASC, $Daten_ary);
unset ($Datum); unset ($Prioritaet);}
else {
@ array_multisort ($Prioritaet, SORT_ASC, $Datum, SORT_DESC, $Daten_ary);
unset ($Datum); unset ($Prioritaet);}

/* 10. Templates fr Textbausteine */
$prototyp_Verweise = "\n" . '<div class="indent"><a href="#<ANKER>"><TITEL><DATUM><NEU></a></div>';
$prototyp_Verweise_abgelaufen = "\n" . '<div  class="indent"><a href="#<ANKER>"><TITEL><NEU></a><span class="Info_grau"> (Artikel ist abgelaufen!) </span><a href="body_CMS.php?Datenbank='.$Datenbank.'&archivieren=<ANKER>"><span class="Info_rot"> (jetzt archivieren) </span></a></div>';
$Prototyp_Texte = "\n" . '<a name="<ANKER>"></a><br /><h2><TITEL></h2>' . "\n" . '<h3><UNTERTITEL></h3>' . "\n" . '<p><ABSAETZE></p>' . "\n" .'<div style="clear:both;"><a href="#Anfang">zum Anfang</a></div><ANHANG_USER><ANHANG_ADMIN></hr>';


//echo '<pre>';print_r($Daten_ary);echo '</pre>';

/* 11. Durchlauf der Datenbloecke */
foreach ($Daten_ary as $key => $Werte)
{
//echo '<pre>';print_r($Werte);echo '</pre>';die;

    /* 11.a) Weiter, wenn (deaktiv ODER Ablaufdatum vorbei und kein Archiv) UND kein Administrator eingeloggt */ 
if (($Werte[3]==0 OR ($Werte[4] < time()AND substr($Datenbank,0,6)!='Archiv'))AND $Rechte != 'Admin')
{continue;}
$T_ANHANG_USER ='';$T_ANHANG_ADMIN='';
if ($Werte[4] > time()){$ArtAbgelaufen = 'Nein';}
else $ArtAbgelaufen = 'Ja';

    /* 11.b) Inhaltsverzeichnis (interne Links) festlegen */
if ($ArchivModus == 'Nein' AND $ArtAbgelaufen =='Ja') {$T_VERWEISE .=  $prototyp_Verweise_abgelaufen;}
else {$T_VERWEISE .=  $prototyp_Verweise;}
$T_TITEL = $Werte[0];
if ($ArchivModus == 'Ja') {$T_DATUM = ' (' . date( ("j.n.Y"),$Werte[2]) . ')';}
else {$T_DATUM ='';}
// Einblendung neu!!! (1 Tag ist 86400)
if ((time() - $Werte[2]) <= 864000)
{$T_NEU = '<span class="L_Hinweisneu">Neu!!!</span>';}
else {$T_NEU = '';}
// Ende Einblendung neu
$T_ANKER = $key;
$T_VERWEISE = str_replace("<ANKER>",$T_ANKER,$T_VERWEISE);
$T_VERWEISE = str_replace("<NEU>",$T_NEU,$T_VERWEISE);
$T_VERWEISE = str_replace("<TITEL>",$T_TITEL,$T_VERWEISE);
$T_VERWEISE = str_replace("<DATUM>",$T_DATUM,$T_VERWEISE);


    /* 11.c) Kopfbereich eines Artikels */
$T_UNTERTITEL = $Werte[1];

    /* 11.d) Abstze */
        /* 11.d)1 Vorbereitung */
$Bldpos_ary = array(
0 => 'style="margin: 10px; display: block; float: none; text-align: center;"',
1 => 'style="margin: 10px 10px 10px 0px; display: block; float: none; text-align: left;"',
2 => 'style="margin: 10px 0px 10px 10px; display: block; float: none; text-align: right;"',
3 => 'style="margin: 0px 10px 10px 0px; float: left;"',
4 => 'style="margin: 0px 0px 10px 10px; float: right;"');

$T_INHALTE .= $Prototyp_Texte;
$AbsNr = 1;
$T_ABSAETZE = '';

        /* 11.d)2 Datendurchlufe */
while (array_key_exists ('Absatz' . $AbsNr,$Werte)){

            /* 11.d)2.a) Bilddaten */
//$aktBilddaten = explode('--y11--',$Werte['Bilddaten' . $AbsNr]); 
$aktBilddaten = $Werte['Bilddaten' . $AbsNr]; 
//echo print_r($Werte);
$T_Bild ='';
if (file_exists($aktBilddaten[0])){
if ($aktBilddaten[1]==5) {$T_Bild ='';} else {
$T_Bild = '<img src="'. $aktBilddaten[0] .'" ' . $Bldpos_ary[$aktBilddaten[1]]. ' width="' . $aktBilddaten[2] . '" border=0>';}
}

            /* 11.d)2.b) Inhalte festlegen */
$aa='';$T_TEXTE='';$FString='';
$T_TEXTE = $Werte['Absatz' . $AbsNr];
                /* - Ergebnis einer Funktion Importieren */
if ($aa = strpos($T_TEXTE,"---IMPORT---")){
$FString = explode('?',substr($T_TEXTE,0,$aa));
$Fname = $FString[0];
if ( @ include ($Fname)) $T_TEXTE = Import($FString[1]);
}
                /* - Datei als iFrame importieren*/
if ($aa = strpos($T_TEXTE,"---IFRAME---")){
$FString = explode('?',substr($T_TEXTE,0,$aa));
$Fname = $FString[0];
$FParameter = array();
$FParameter = explode('&',$FString[1]);
foreach ($FParameter as $value){
$temp = explode('=',$value);
$ary_Parameter[$temp[0]]=$temp[1];}
if ($ary_Parameter[Hoehe]>100){$F_Hoehe=$ary_Parameter[Hoehe];}
else $F_Hoehe='400'; 
$T_TEXTE ='<iframe src="' . $FString[0] .'" frameborder="none" width="98%" height="' . $F_Hoehe .'pt"></iframe>';
}


$T_ABSAETZE .='<div style="margin: 0 0 20px 0; clear:both;">' .  $T_Bild . $T_TEXTE . '</div>';
$AbsNr++;
}

    /* 11.e) Endbereich eines Artikels */

        /* 11.e)2. Links fr berechtigte User */
if ((($UserID==$Werte[7] AND $Rechte == 'User') OR $Rechte == 'Admin') AND $ArchivModus == 'Nein'){
$T_ANHANG_USER = '<div class="Link_bearbeiter"><a href="body_CMS_Formular.php?Artikel='. $T_ANKER .'&Datenbank='.$Datenbank.'">bearbeiten</a></div>';}

        /* 11.e)3. Links fr Administrator (zustzlich zu 11.e.2) */
if ( $Rechte == 'Admin'){
if ($ArtAbgelaufen =='Nein' OR $ArchivModus =='Ja') {
$T_Ablaufdatum = 'Ablaufdatum: ' . date( ("j.n.Y"),$Werte[4]) ;}
else {$T_Ablaufdatum = '<span class="Info_rot">Ablaufdatum: ' . date( ("j.n.Y"),$Werte[4]) . '</span>';
}
if ($ArchivModus =='Ja'){
$T_ANHANG_ADMIN = '<div class="Link_bearbeiter"><a href="body_CMS_Formular.php?Artikel='. $T_ANKER .'&Datenbank='.$Archivdatei.'&submit_Artikel=ArchivLoeschen">loeschen</a></div>';

}
$T_ANHANG_ADMIN .= '<div class="Info_grau">Prioritt: ' . $Werte[5] . ' ** Status: ' . $Werte[3] . ' ** Datum: ' . date( ("j.n.Y"),$Werte[2]). ' ** <ABLAUFDATUM> ** Autor: ' . $Werte[7] . '</div>';
$T_ANHANG_ADMIN = str_replace("<ABLAUFDATUM>",$T_Ablaufdatum,$T_ANHANG_ADMIN);
}

        /* 11.e)4. Montage des Textes */
$T_INHALTE = str_replace("<ANKER>",$T_ANKER,$T_INHALTE);
$T_INHALTE = str_replace("<TITEL>",$T_TITEL,$T_INHALTE);
$T_INHALTE = str_replace("<UNTERTITEL>",$T_UNTERTITEL,$T_INHALTE);
$T_INHALTE = str_replace("<ABSAETZE>",$T_ABSAETZE,$T_INHALTE);
//$T_INHALTE = str_replace("<BILD>",$T_Bild,$T_INHALTE);
//$T_INHALTE = str_replace("<TEXTE>",$T_TEXTE,$T_INHALTE);
$T_INHALTE = str_replace("<ANHANG_USER>",$T_ANHANG_USER,$T_INHALTE);
$T_INHALTE = str_replace("<ANHANG_ADMIN>",$T_ANHANG_ADMIN,$T_INHALTE);
}             //Durchlauf Datenblcke Ende (Punkt 10.)

/* 12. Messung der Berechnungszeit der Seite Ende (siehe 1.) */
}
$T_INHALTE_OHNE = $T_INHALTE;
$T_INHALTE .= '<div class="Info_grau"><br>Das Erstellen dieser Seite dauerte ' . round((microtime_float()-$Start_time)/$e,3) . ' Sekunden</div>';

/* 13. Montage und Ausgabe der Daten */
$template = implode("",file('template_CMS.php'));
$template = str_replace("<CSS_DATEI>",$T_CSS,$template);
$template = str_replace("<TITEL>",$T_GESAMTTITEL,$template);
$T_VERWEISE .= '<br />'; 
$template = str_replace("<VERWEISE>",$T_VERWEISE,$template);
$template = str_replace("<NEUER_ARTIKEL>",$T_NEUER_ARTIKEL,$template);
$cachetext = $template; 
$template = str_replace("<INHALTE>",$T_INHALTE,$template);
echo $template;


/* 14. Caching Schreibprozess*/
if ($CacheOrder =='cachen') {
$cachetext=str_replace("<INHALTE>",$T_INHALTE_OHNE,$cachetext);
Cache_schreiben($CacheDatei,$cachetext);}
?>