<?PHP
/* 1. Cache schreiben*/
/* 2. Cache einlesen*/
/* 3. Datensatz aus Archiv lschen */
/* 4. Datensatz bearbeiten */
/* 5. Neuer Artikelplatz */
/* 6. Artikeldatei schreiben */
/* 7. Artikel lesen*/
/* 8. Verzeichnis_durchsuchen */
/* 9. Datum in Timestamp umwandeln*/
/* 10. Meldungen*/
/* 11. Datei umleiten mit Java-script */



/* 1. Cache schreiben*/
function Cache_schreiben ($CacheDatei,$Inhalt){
global $Start_time;
if ($datei = @ fopen($CacheDatei,"wb")){
@ fputs($datei,$Inhalt);
@ fclose($datei);
}
}

/* 2. Cache einlesen*/
function Cache_lesen ($CacheDatei,$aktCacheDateien){
if (file_exists($CacheDatei)){
$aktDatum;
foreach ($aktCacheDateien as $DatVal){
$aktDatum = max(filemtime($DatVal),$aktDatum);
}
$Datum_Cache = filemtime($CacheDatei);
    //Ist Cachedatei aktuell? Ja
if ($Datum_Cache>$aktDatum){
    //Cachedatei ffnen ? Ja
if ($datei = @ fopen($CacheDatei,"r")){
while (! feof($datei))
{$Ergebnis .= @ fgets($datei,1024);}
@ fclose($datei);
echo $Ergebnis;die;
}
unlink($CacheDatei);
}
}
RETURN 'cachen';}

/* 3. Datensatz aus Archiv lschen */
function Datensatz_Archiv_loeschen ($Datenbank,$Artikel) {
$alleDaten = Artikel_lesen($Datenbank);
unset ($alleDaten[$Artikel]);
Artikeldatei_Schreiben($Datenbank,$alleDaten);
}

/* 4. Datensatz bearbeiten */
function Datensatz_bearbeiten($file,$Modus="bearbeiten",$Datenneu)
{
global $AbsNr;
$key = $Datenneu['Schluessel'];
$transArtikelTAG = array('<' => '', '>' => '');
$transArtikel = array("\n" => '</p><p>', "\r" => '', '---(' => '<', ')---' => '>');

if($Datenneu[Absatz . $AbsNr]) {
$Datenneu[Absatz . $AbsNr]= strtr($Datenneu[Absatz . $AbsNr],$transArtikelTAG);
$Datenneu[Absatz . $AbsNr]= strtr($Datenneu[Absatz . $AbsNr],$transArtikel);}

//echo '<pre>'; print_r ($Datenneu); echo '</pre>';//die;
$alleDaten = Artikel_lesen($file);
if ($Modus == "loeschen") //Lschfunktion veraltet
{unset($alleDaten[$key]);
Artikeldatei_Schreiben($file,$alleDaten);}

if ($Modus == "bearbeiten")
{if (is_array($Datenneu))
{unset($alleDaten[$key]);
$alleDaten[$key]=$Datenneu;
Artikeldatei_Schreiben($file,$alleDaten);}
else {Meldung ('!Ary');}
}
return $alleDaten;
}

/* 5. Neuer Artikelplatz */
function Neuer_Artikelplatz($file="Alle"){
if ($file == "Alle"){
$AlleFiles = Verzeichnis_durchsuchen('.','/(.*)(\.dat$)/i','lassen');
//print_R($AlleFiles);die;
}
else {$AlleFiles = array ($file);}
foreach ($AlleFiles as $temp_file){
$alleDaten = Artikel_lesen($temp_file,'Artikel');
foreach ($alleDaten as $key => $value)
{$Neuzahl = max(substr($key,7),$Neuzahl);}
$Neuzahl++;
}
while(count (Verzeichnis_durchsuchen('.','/(^ARTIKEL)(' . $Neuzahl . ')(.*)(\.JPG$)/i'))>0) {$Neuzahl++;}

$Ergebnis = 'Artikel' . $Neuzahl;
return $Ergebnis;
}

/* 6. Artikeldatei schreiben */
function Artikeldatei_Schreiben($file,$alleDaten)
{
if (
$handle = @ fopen($file, "wb")){
foreach ($alleDaten as $key => $Datensatz)
{
$Zeile = '[' . $key . ']' . "\n";
fputs ($handle, $Zeile);
for ($i=1;$i<30;$i++)
{if($Datensatz['Bilddaten' . $i]) {$Datensatz['Bilddaten' . $i]=implode('--y11--',$Datensatz['Bilddaten' . $i]);}
}

foreach ($Datensatz as $key => $Wert)
{
$Zeile = $key . '=' . $Wert;
$Zeile .=   "\n";
$trans = array('' => '&ouml;', '' => '&auml;', '' => '&uuml;', '' => '&Ouml;', '' => '&Auml;', '' => '&Uuml;', '' => '&szlig;', '\"' => '&quot;', '\'' => '&quot;');
fputs ($handle, strtr($Zeile,$trans));}
fputs ($handle, "\n");
}
fclose ($handle);
Return  TRUE;}
else {Return  False;}
}

/* 7. Artikel lesen*/
function Artikel_lesen($file,$Anfangsstring="") {
$Suchstring= '[' . $Anfangsstring;
$Ergebnis = array();
if($Dateiinhalt = @ fopen ($file, "r")){
$AktZeile;
while (! feof($Dateiinhalt)) {
  if (substr($AktZeile,0,strlen($Suchstring)) == $Suchstring){
$AktKey = substr($AktZeile,1,(strlen($AktZeile)-2));
do {$AktZeile = trim(fgets($Dateiinhalt, 4096));
if ($k = strpos ($AktZeile,"=")){
$temp[0] = substr($AktZeile,0,$k);
$temp[1] = stripslashes(substr ($AktZeile,$k + 1));
if (substr($temp[0],0,9)=='Bilddaten'){
$temp[1]=explode('--y11--',$temp[1]);
if ($temp[1][1]==''){$temp[1][1]='0';}
if ($temp[1][2]==''){$temp[1][2]='100';}}
$Ergebnis[$AktKey][$temp[0]]=$temp[1];
} 
}
while (substr($AktZeile,0,1) != '[' AND ! feof($Dateiinhalt));
}
else {$AktZeile = trim(fgets($Dateiinhalt, 4096));}
}
fclose ($Dateiinhalt);
}
else {Meldung('!File');}
return ($Ergebnis);
}

/* 8. Verzeichnis_durchsuchen */
function Verzeichnis_durchsuchen($Verzeichnis,$Suchmuster,$Modus="strtoupper")
{
$ergebnis ="";
if (is_dir($Verzeichnis)) {
$ergebnis = array();
    if ($dh = opendir($Verzeichnis)) {
        while (($file = readdir($dh)) !== false) {
           if (preg_match ($Suchmuster,$file))
           {
           if ($Modus=='strtoupper'){
           array_push($ergebnis, strtoupper($file));}
           else {array_push($ergebnis,$file);}
           }
        }
        closedir($dh);
    }
else $ergebnis = 'Das angegebene Verzeichnis kann nicht geffnet werden.';
}
else $ergebnis = 'Das angegebene Verzeichnis existiert nicht.';
@ sort($ergebnis);
return $ergebnis;
}

/* 9. Datum in Timestamp umwandeln*/
function f_timestamp($Eingabedatum){
$Werte = explode ('.',$Eingabedatum);
if (@ checkdate($Werte[1],$Werte[0],$Werte[2])==TRUE)
RETURN @ mktime(0,0,0,$Werte[1],$Werte[0],$Werte[2]);
}

/* 10. Meldungen*/
function Meldung($a="",$b="",$c=""){
switch ($a) {
case 'Endzeit_Falsch':
echo '<div class="L_Warntext">Sie haben kein gltiges Ablaufdatum eingegeben! Verwenden Sie bitte das Format 3.6.2007!</div>';
break;
case 'gespeichert':
echo '<div class="L_Warntext">Ihre Daten wurden gespeichert!</div>';
break;
case 'geloescht':
echo '<div class="L_Warntext">Der Datensatz wurde erfolgreich gelscht!</div>';
break;
case '!File':
echo '<div class="L_Warntext">Die Datei ' . $b . ' konnte leider nicht geffnet werden</div>';
break;
case '!Ary':
echo '<div class="L_Warntext">Der neue Datensatz ist kein Array!</div>';
break;
case '!Bild':
echo '<div class="L_Warntext">F&uuml;r diesen Absatz existiert kein Bild ('.$b.')!</div>';
break;
case 'nicht_archivierbar':
echo '<div class="L_Warntext">Archivierung leider nicht m&ouml;glich! Entweder existiert die Datei ' . $b . ' nicht oder sie kann nicht beschrieben werden.</div>';
break;
case 'Archiveintrag_existiert':
echo '<div class="L_Warntext">Der Archiveintrag ' . $b . ' existiert bereits in der Datei '. $c .'. Archivierung nicht mglich.</div>';
break;
case 'Datei_geschrieben':
echo '<div class="L_Warntext">Datei ' . $b . ' wurde gespeichert.</div>';
break;
case 'Datei_nicht_geschrieben':
echo '<div class="L_Warntext">Datei ' . $b . ' konnte nicht gespeichert werden.</div>';
break;
case '!geloescht':
echo '<div class="L_Warntext">Datei ' . $b . ' konnte leider nicht gel&ouml;scht werden.</div>';
break;

case 'verbotene_Zeichen':
echo '<div class="L_Warntext">Ihre Eingabe enthlt nicht erlaubte Zeichen ( '.$b.')</div>';
break;
case 'NeuerName_existiert':
echo '<div class="L_Warntext">Vorhandene Archivdatei ' . $b . ' wird geladen! Eventuelle &Auml;nderungen am Titel der Archivdatei werden dabei nicht ber&uuml;cksichtigt.</div>';
break;


default:
echo '<div class="L_Warntext">unbekannte Meldung</div>';
}
}


/* 11. Datei umleiten mit Java-script */
function umleiten($Ziel,$Zeit){
$Ergebnis = '<script language="JavaScript"><!-- 
function umleiten() {location.href ="'. $Ziel .'";}
setTimeout(\'umleiten()\','. ($Zeit*1000) .'); 
--></script>';
return $Ergebnis;
}
 
?>